#ifndef _INTERFACE_H_
#define _INTERFACE_H_

#include "commdef.h"

#define	IF_FAIL_WRITE		(-1)
#define	IF_FAIL_READ		(-2)
#define	IF_NEED_RETRY		(-3)
#define	IF_OVER_MTU_SIZE	(-4)

#ifdef _WIN32
class ARCLIB_API ArcInterface
#else
class ArcInterface
#endif
{
public:	
	virtual ~ArcInterface()
	{
	}
	virtual int send(const char *outBuf, int outLen) = 0;	
	virtual int recv(char *inBuf, int inLen) = 0;
	virtual int syncSend(const char *outBuf, int outLen, char *inBuf, int inLen) = 0;

    //
	//	MTU: Maximum transmission unit
	//  the size (in bytes) of the largest packet that this layer can carry out.	
	//	
	virtual int	 getMTU() = 0;
	virtual void *getDeviceHandle() = 0;

	// These two member functions will be called by the syncSend() member function
	// to ensure the synchronization of send() and recv() to the single controller.
	// The requirelock() will be called before the send() called, 
	// and releaselock() will be called after the recv() called.
	virtual void requirelock(){}
	virtual void releaselock(){}
};


#endif
